(use lazy-ffi srfi-4)

#~"libc.so.6" 
(#~printf "%d -> %g, ok: %s\n" 123 45.67 "hello")

(print "sleeping...")
(#~sleep 1)

#~"libm.so.6"

(print (#~sin 33.4 return: double:))    ;==> 0.915809602890819
(print (#~tolower #\A return: char:))   ;==> #\a

(let* ([box (f64vector 0)]
       [r (#~modf 123.456 box return: double:)] )
  (pp (list r box) ) );   ==> (0.456 #f64(123.0))
